/*
Copyright (C) 2007 Observatoire de Paris-Meudon

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier conformment aux dispositions de la Licence Publique Gnrale GNU, telle que publie par la Free Software Foundation ; version 2 de la licence, ou encore ( votre choix) toute version ultrieure.

Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail, voir la Licence Publique Gnrale GNU .

Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en mme temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
*/

package diaporama;

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

/**
 * Diaporama d'images, permettant une slection parmis un troupeau de boutons
 * Paramtres :
 * <ul>
 * <li>Fichiers d'images : image1, image2, ...
 * <li>Titres : titre1, titre2, ...
 * <li>Lgendes : legende1, legende2, ...
 * </ul>
 */
public class Diaporama extends Applet implements ItemListener {
    
    private Vector listeImages; // de ImageDiapo
    private int nbImages;
    private Dimension imgdim;
    private ImageCanvas ic;
    private CheckboxGroup cbg;
    private Checkbox[] boutons;
    private TextArea zoneLegende;
    
    public void init() {
        listeImages = new Vector();
        int n = 0;
        while (getParameter("image" + (n+1)) != null) {
            n++;
            listeImages.addElement(
                new ImageDiapo(this, getParameter("image" + n), getParameter("titre" + n), getParameter("legende" + n)));
        }
        nbImages = n;
        
        setLayout(new BorderLayout());
        imgdim = ((ImageDiapo)listeImages.elementAt(0)).getDimension();
        
        ic = new ImageCanvas(imgdim.width, imgdim.height);
        ic.setImage(((ImageDiapo)listeImages.elementAt(0)).getImage());
        add(ic, BorderLayout.NORTH);
        
        int wGrille = (int)Math.ceil(Math.sqrt(nbImages));
        if (nbImages == 3)
            wGrille = 3;
        int hGrille = (int)Math.ceil(((double)nbImages) / wGrille);
        Panel panelSud = new Panel(new BorderLayout());
        Panel panelBoutons = new Panel(new GridLayout(hGrille, wGrille));
        cbg = new CheckboxGroup();
        boutons = new Checkbox[nbImages];
        for (int i=0; i<nbImages; i++) {
            boutons[i] = new Checkbox(((ImageDiapo)listeImages.elementAt(i)).getTitre(), cbg, i==0);
            boutons[i].addItemListener(this);
            panelBoutons.add(boutons[i]);
        }
        panelSud.add(panelBoutons, BorderLayout.NORTH);
        
        zoneLegende = new TextArea(((ImageDiapo)listeImages.elementAt(0)).getLegende(), 4, 100, TextArea.SCROLLBARS_VERTICAL_ONLY);
        zoneLegende.setEditable(false);
        panelSud.add(zoneLegende, BorderLayout.CENTER);
        add(panelSud, BorderLayout.CENTER);
        
        validate();
    }
    
    protected void majImage() {
        int sel = getSelection();
        if (sel == -1)
            return;
        ic.updateImage(((ImageDiapo)listeImages.elementAt(sel)).getImage());
    }
    
    protected void majLegende() {
        int sel = getSelection();
        if (sel == -1)
            return;
        zoneLegende.setText(((ImageDiapo)listeImages.elementAt(sel)).getLegende());
    }
    
    protected int getSelection() {
        Checkbox chksel = cbg.getSelectedCheckbox();
        int sel = -1;
        for (int i=0; i<boutons.length; i++)
            if (boutons[i] == chksel)
                sel = i;
        return(sel);
    }
    
    public void itemStateChanged(ItemEvent e) {
        majImage();
        majLegende();
    }
}
