/*
Copyright (C) 2007 Observatoire de Paris-Meudon

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier conformment aux dispositions de la Licence Publique Gnrale GNU, telle que publie par la Free Software Foundation ; version 2 de la licence, ou encore ( votre choix) toute version ultrieure.

Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail, voir la Licence Publique Gnrale GNU .

Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en mme temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
*/

package diaporama;

import java.awt.*;
import java.awt.image.*;

/**
 * Zone d'affichage d'une image
 */
public class ImageCanvas extends Canvas {
    Dimension tailleImage;
    Image image = null;
    
    public ImageCanvas(int w, int h) {
        setSize(w, h);
        tailleImage = new Dimension(w, h);
    }
    
    /**
     * Pour dfinir l'image la premire fois, sans besoin de faire un repaint
     */
    public void setImage(Image im) {
        image = im;
    }
    
    public Dimension getPreferredSize() {
        return tailleImage;
    }
    
    public Dimension getMinimumSize() {
        return tailleImage;
    }
    
    public void paint(Graphics g) {
        Dimension tailleZone = getSize();
        int x = (tailleZone.width - tailleImage.width)/2;
        int y = (tailleZone.height - tailleImage.height)/2;
        if (image != null)
            g.drawImage(image, x, y, null);
        g.drawRect(x, y, tailleImage.width - 1, tailleImage.height - 1);
    }
    
    public void update(Graphics g) {
        paint(g);
    }
    
    /**
     * Change l'image et met  jour l'affichage
     */
    public void updateImage(Image im) {
        image = im;
        repaint();
    }
}
