/*
Copyright (C) 2007 Observatoire de Paris-Meudon

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier conformment aux dispositions de la Licence Publique Gnrale GNU, telle que publie par la Free Software Foundation ; version 2 de la licence, ou encore ( votre choix) toute version ultrieure.

Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail, voir la Licence Publique Gnrale GNU .

Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en mme temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
*/

package diaporama;

import java.applet.Applet;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.MediaTracker;

public class ImageDiapo {
    private Applet applet;
    private Image img;
    private String titre;
    private String legende;
    private boolean charge;
    
    public ImageDiapo(Applet applet, String nomFichier, String titre, String legende) {
        this.applet = applet;
        img = applet.getImage(applet.getDocumentBase(), nomFichier);
        this.titre = titre;
        this.legende = legende;
        charge = false;
    }
    
    public Image getImage() {
        if (!charge)
            chargerImage();
        return(img);
    }
    
    public String getTitre() {
        return(titre);
    }
    
    public String getLegende() {
        return(legende);
    }
    
    public Dimension getDimension() {
        if (img == null)
            return(new Dimension(100, 100));
        if (!charge)
            chargerImage();
        int hauteur = img.getHeight(null);
        int largeur = img.getWidth(null);
        return(new Dimension(largeur, hauteur));
    }
    
    protected void chargerImage() {
        MediaTracker tracker = new MediaTracker(applet);
        tracker.addImage(img, 0);
        try {
            tracker.waitForAll();
        } catch (InterruptedException ex) {
            System.err.println("ImageDiapo: InterruptedException: " + ex.getMessage());
        }
        charge = true;
    }
}
