/*

Copyright (C) 2012  Observatoire de Paris

The JavaScript code in this page is free software: you can
redistribute it and/or modify it under the terms of the GNU
General Public License (GNU GPL) as published by the Free Software
Foundation, either version 3 of the License, or (at your option)
any later version.  The code is distributed WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE.  See the GNU GPL for more details.

As additional permission under GNU GPL version 3 section 7, you
may distribute non-source (e.g., minimized or compacted) forms of
that code without the copy of the GNU GPL normally required by
section 4, provided you include this license notice and a URL
through which recipients can access the Corresponding Source.

*/

var listeImages;
var boutonActif;

function lireParametres() {
    var parametres = new Array();
    var searchString = window.location.search.substring(1);
    var params = searchString.split("&");
    
    for (var i=0; i<params.length; i++) {
        var nomval = params[i].split("=");
        // remarque: les paramètres de l'URL doivent être encodés en UNICODE
        parametres[nomval[0]] = decodeURIComponent(nomval[1]);
    }
    return(parametres);
}

function init() {
    var parametres = lireParametres();
    var chemin_fichiers = parametres['chemin_fichiers'];
    var chemin;
    if (chemin_fichiers != null)
        chemin = chemin_fichiers;
    else
        chemin = '';
    listeImages = new Array();
    for (var i=0; parametres['image' + (i+1)] != null; i++) {
        listeImages[i] = new ImageDiapo(chemin + parametres['image' + (i+1)],
            parametres['titre' + (i+1)],
            parametres['legende' + (i+1)]);
    }
    if (listeImages.length == 0) {
        alert("Il faut passer des paramètres imagex titrex et legendex à l'URL");
        return;
    }
    var divchoix = document.getElementById('divchoix');
    for (var i=0; i<listeImages.length; i++) {
        var bouton = document.createElement('span');
        bouton.setAttribute('id', 'b'+i);
        bouton.className = 'bouton';
        var contenu = document.createTextNode(listeImages[i].titre);
        bouton.appendChild(contenu);
        if (bouton.addEventListener)
            bouton.addEventListener('click', clicBouton, false);
        else
            bouton.attachEvent('onclick', clicBouton);
        divchoix.appendChild(bouton);
    }
    selectionImage(0);
}

function clicBouton(e) {
    var bouton = (e.target || e.srcElement);
    var id = bouton.getAttribute('id');
    if (id == null || id.length < 1)
        return;
    selectionImage(id.substring(1));
}

// le nom "selection" ne marche pas avec IE !!!
function selectionImage(numero) {
    var bouton = document.getElementById('b'+numero);
    if (boutonActif != null)
        boutonActif.className = boutonActif.className.replace(' actif', '');
    bouton.className += ' actif';
    boutonActif = bouton;
    var image = document.getElementById('image');
    if (image == null) {
        var divimage = document.getElementById('divimage');
        image = document.createElement('img');
        image.setAttribute('id', 'image');
        divimage.appendChild(image);
    }
    image.setAttribute('src', listeImages[numero].image);
    var divlegende = document.getElementById('divlegende');
    var texte = divlegende.firstChild;
    if (listeImages[numero].legende != undefined) {
        if (texte != null)
            texte.nodeValue = listeImages[numero].legende;
        else
            divlegende.appendChild(document.createTextNode(listeImages[numero].legende));
    } else {
        if (texte != null)
            divlegende.removeChild(texte);
    }
}

function ImageDiapo(image, titre, legende) {
    this.image = image;
    this.titre = titre;
    this.legende = legende;
    return(this);
}
